#!/usr/bin/python
# coding=utf-8
import sys
import logging
import codecs
from xml.dom import minidom

class XmlRepresentation(object):
    _doc = None

    def __init__(self, filename):
        self._doc = minidom.parse(filename)

    """
     Task 1, part A: Complete this method. You are likely to consult the Python
     xml.dom documentation when working on this task.

     You can suppose that the input document is always valid, i.e. its
     structure fulfills the criteria specified in the comments inside the
     document company.xml.
     
     Increase the salary for a person identified by its pid
     
     pid -- identifier of the person whom the salary should be
     increased.
     percent -- percentual increase, eg. 10 means the new salary will be
     110 % of the current one.
     
     returns: the person element where the salary has been increased by the
     method. If such a person does not exist, the method returns null.

    """
    def increase_salary(self, pid, increase):
        pass


    """
     Task 1, part B: Complete this method. You are likely to consult the Python
     xml.dom documentation when working on this task.

     You can suppose that the input document is always valid, i.e. its
     structure fulfills the criteria specified in the comments inside the
     document company.xml.
     
     returns: average salary of all heads of division in the company as double.
    """
    def get_head_average_salaries(self):
        return 0



    """
     Task 1, part C: Complete this method. The method adds a new note to an
     existing person identified by its person ID (pid) and returns 
     this person element. If such a person does
     not exist, the method does nothing and returns null.

     pid -- pid of the person to add the note to this person. pid must not be
        null nor empty (the method does not check it)
     note -- the note to be added to the person with the given pid

     returns: the Element person with the given pid and new note added 
     or null if such person Element does not exist.

    """
    def add_note(self, pid, note):
        pass

    def serialize_to_xml(self, filename):
        outputfile = codecs.open(filename, "wb", "utf-8")
        self._doc.writexml(outputfile, encoding="utf-8")

def task1():
    if len(sys.argv) != 3:
        logging.error("You have to enter input and output file")
        sys.exit(1)

    inputfilename = sys.argv[1]
    outputfilename = sys.argv[2]
    percent = 20
    xml = XmlRepresentation(inputfilename)
    print "Task 1.B Average salaries of heads: ", xml.get_head_average_salaries()
    print "Task 1.A Salary of person pid=1 increased by ", percent, "%"
    print xml.increase_salary("1", percent).toxml()
    print "Task 1.B Average salaries of heads is now: ", xml.get_head_average_salaries()

    print "Task 1.C Person with pid=1 is now:"
    result = xml.add_note("1", "New note to person 1")
    if result is not None:
        print result.toxml()
    xml.serialize_to_xml(outputfilename)

if __name__ == "__main__":
    task1()
